import processing.serial.*;

Serial port;


int mainwid = 1300;
int mainheight = 800;

int displaywid = 650;
int displayheight = 650;
int midpointx = displaywid/2+50;
int midpointy = displayheight/2+50;

int controlwid = 400;
int controlheight = 600;

int datawid = 1175;
int datalen = 50;

int[][] pointdata = new int [400][2];
float[][] mappeddata = new float [400][2];
int yoffset = 50 + displayheight / 2;
int xoffset = 50 + displaywid / 2;
float scale = 10;

float carangle = 0;
float carx = 0;
float cary = 0;


int tSx0;
int[] outdata = new int[5];

boolean indir = false;
boolean indir2 = false;

int x;
int angle;
int distance;
int type; //1/2 F/B, 3/4 L/R

int mainboard = 1;
int processing = 3;

void setup()
{
 size (1300,800);   //size
 port = new Serial(this, Serial.list()[1], 9600);
 port.bufferUntil('\n');
 drawSetup();
}




void drawSetup()
{
 fill (125);
 rect (0,0,mainwid,mainheight);   //main area rectangle

 fill (0);
 line (50,50+displayheight/2,displaywid+50,displayheight/2+50); //x axis
 line (50+displaywid/2,50,displaywid/2+50,displayheight+50);    //y axis
 for(int i = 1; i < 8; i++)
 {
   line((midpointx+i*displaywid/2/8),midpointy-5,midpointx+i*displaywid/2/8,midpointy+5);
   line((midpointx-i*displaywid/2/8),midpointy-5,midpointx-i*displaywid/2/8,midpointy+5);
   line(midpointx-5,(midpointy+i*displaywid/2/8),midpointx+5,(midpointy+i*displaywid/2/8));
   line(midpointx-5,(midpointy-i*displaywid/2/8),midpointx+5,(midpointy-i*displaywid/2/8)); //grid
 }
 text((scale/10 + "cm"), midpointx+displaywid/16-5, midpointy+20); //text for scale
 fill (200);
 rect (displaywid+100+75,50,controlwid,controlheight); //controls interface
 fill(250);
 rect (50, mainheight-70,datawid,datalen); //data line
 fill(0);
 text("Car Angle:" + carangle,60, mainheight-50);
 text("Car X Position:" + carx,160, mainheight-50);
 text("Car Y Position:" + cary,290, mainheight-50);
 
 controlpannelsetup();
}

void controlpannelsetup()
{
 fill(0,128,128);
 rect(855,80,170,170);
 fill(255,180,0);
 rect(855,80,170,50);
 rect(855,200,170,50);
 fill(255,120,0);
 rect(855,130,50,70);
 rect(975,130,50,70);
 fill(0);
 text("forward",910,110);
 text("backward",910,230);
 text("left",872,170);
 text("right",990,170);
 text("scan",930,170);
}




void mousePressed()
{

 delay(100);
 if(mouseX > 855 && mouseY > 80 && mouseX < 855 + 170 && mouseY < 80 + 50){print("forward"); type = 1; move();}
 if(mouseX > 855 && mouseY > 200 && mouseX < 855 + 170 && mouseY < 200 + 50){print("backward"); type = 2; move();}
 if(mouseX > 855 && mouseY > 130 && mouseX < 855 + 50 && mouseY < 130 + 70){print("left"); type = 3; move();}
 if(mouseX > 975 && mouseY > 130 && mouseX < 975 + 50 && mouseY < 130 + 70){print("right"); type = 4;move();}
 if(mouseX > 855 + 50 && mouseY > 80 + 50 && mouseX < 975 && mouseY < 200){
  print("scan");
  String message = "";
  message = "<" + "a" + "9" + "," + "0" + "," + ">";
    print(message);
  port.write(message);

  }        // print here will be replaced with btport print for final code
 
 if(indir && mouseX > 1050 && mouseX < 1050 + 160 && mouseY > 115 && mouseY < 115 + 30)
 {
   
   drawSetup();
   controlpannelsetup();
   
   move();
  
  fill(0);
  rect(mouseX, 125, 5, 10);
  
  if(type == 3 || type == 4){
  float fx = map(mouseX, 1050, 1050 + 160, 0, 180);
  x = round(fx);
  angle = x;
  print(angle);
  text("angle: " + x, 1161, 160);
  }
  
  else if(type == 1 || type == 2)
  {
    float fx = map(mouseX, 1050, 1050 + 160, 0, 100);
    x = round(fx);
    if(type == 2){text("distance: -" + x + "cm", 1161, 160);}
    else if(type == 1){text("distance: " + x + "cm", 1161, 160);}
    distance = x;
  }
  
  indir2 = true;
  
 }
 
 if(indir2 && mouseX > 1100 && mouseY > 150 && mouseX < 1100 + 50 && mouseY < 150 + 50)
 {
   indir = false; 
   indir2 = false; 
   print("confirm"); 
   
   
   String message = "";
   
   if(type == 3){
     message =  "<" + "a" + "3" + "," + angle + "," + ">";
     print(message);
   port.write(message);
   }
   else if(type == 4){
   message = "<" + "a" + "4" + "," + angle + "," + ">";
   port.write(message);
   print(message);
   }
   else if(type == 1){
   message = "<" + "a" + "1" + "," + distance + "," + ">";
   port.write(message);
   print(message);
   }
   else if(type == 2){
   message = "<" + "a" + "2" + "," + distance + "," + ">";
   port.write(message);
   print(message);
   }

//prints here will be replaced with btport prints to send the data for movements





  drawSetup();
 }
 if(indir && mouseX > 1050 && mouseY > 150 && mouseX < 1050 + 50 && mouseY < 150 + 50)
 {
   indir = false;
   indir2 = false; 
   print("reset");
   drawSetup();
 }
 
 
}


 void move()
 {
   indir = true;
   fill(10);
   rect(1050,115,160,30);
   fill(250);
   rect(1050,125,160,10);
   fill(200);
   rect(1110,150,50,50);
   fill(0);
   text("confirm",1115,175);
   fill(200);
   rect(1050,150,50,50);
   fill(0);
   text("reset",1060,175);
   delay(500);

 }






void draw()
{
mapdata();
fill(255);
for(int i = 0; i < mappeddata.length; i++)
{
  if(mappeddata[i][0] == 0){break;}
  rect(mappeddata[i][0],mappeddata[i][1],5,5);
}
delay(1000);

  
  
}


void serialEvent(Serial port) {
   port.readStringUntil('<');
   String data = port.readString(); //catch serial data 
   print(data);
  try {
    
    int[] input = int(data.trim().split(",")); //split input string by ,
        for(int i = 0; i < 5; i++){
     println(input[i]);
   }
    if(input[0] == 1)
    
    {
    for(int i = 1; i < input.length; i+=2){ //for each pos in input data
     for(int j = 0; j < pointdata.length; j++){      
      if(pointdata[j][0] == 0){ //check if value at incrementing pointer is set, if set, do nothing and continue, if not set, add more data starting from here
      pointdata[j][0] = input[i];
      pointdata[j][1] = input[i+1];
      break;
      }
    }
   }

  }








  }
  catch(Exception e) { //java do java reeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
    e.printStackTrace();
  }
// mapdata();
 //drawpoints();
}




void mapdata()
{
  for(int i = 0; i < pointdata.length; i++)
  {
   float mappedpointx = pointdata[i][0]*1/scale;
   float mappedpointy = pointdata[i][1]*1/scale;
   mappeddata[i][0] = mappedpointx + xoffset;
   mappeddata[i][1] = mappedpointy + yoffset;
  }
/*  for(int i = 0; i < mappeddata.length; i++)
  {
   if((mappeddata[i][0] > displaywid + 50 || mappeddata[i][0] < 50) || (mappeddata[i][1] > displayheight + 50 || mappeddata[i][1] < 50))
  {
   scale *= 2;
  }
 }
 */
}
